// --------------------------------------------------------------------------------
// "WebPageDump" Firefox Extension        
// --------------------------------------------------------------------------------
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WepPageDump.
 *
 * The Initial Developer of the Original Code is Bernhard Pollak.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */      
// --------------------------------------------------------------------------------




var gBrowserWindow = null;      
var gExceptLocation = "about:blank";    
var gCallback = "";     



function wpdWindowLoaded()  
{                 
  try {                      
  	// this will be called multiple times if the page contains more than one document (frames, flash,...)
    //var browser=this.document.getElementById("content");
  	var browser = this.top.getBrowser();          
  	// each time we have to check if the page is fully loaded...
  	if (!(browser.webProgress.isLoadingDocument || browser.contentDocument.location == gExceptLocation)) {   	    	  
      dump("[commandline.js] [wpdWindowLoaded] window finally loaded\n");	 
      gBrowserWindow.removeEventListener("load",wpdWindowLoaded,true);    
      dump("[commandline.js] [wpdWindowLoaded] calling "+gCallback+"\n");	 
      gBrowserWindow.setTimeout(gCallback, 0);   
    }      
  } catch (ex)  {
    dump("[commandline.js] [wpdWindowLoaded] EXCEPTION: "+ex+"\n");
  }
}         

function wpdOpenWindow(aURI,aCallback)
{     
  try {                           
    dump("[commandline.js] [wpdOpenWindow] aURI.spec is: "+aURI.spec+"\n");  
  	var argStr = Components.classes["@mozilla.org/supports-string;1"].getService(Components.interfaces.nsISupportsString);
    argStr.data = aURI.spec;             
    gCallback = aCallback;
    gExceptLocation = "about:blank";
    if (aURI.spec=="about:blank") gExceptLocation="";   
                                          
    // get the browser chrome url (normally "chrome:///content/browser")
    // could be hardcoded as well, but this is the correct way
    var prefSvc = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var browserChromeURL = prefSvc.getCharPref("browser.chromeURL");
    
    // open the window with nsIWindowWatcher as stated on the mozilla developer webpage
  	var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
  	gBrowserWindow = wwatch.openWindow(null, browserChromeURL, "_blank", "chrome,dialog=no,all", argStr);			
    
    // now we add a "load" event listener
  	// dump("wpd: wpdOpenWindow - setting timeout\n"); 
  	gBrowserWindow.addEventListener("load",wpdWindowLoaded, true);  
  } catch (ex)  {
    dump("[commandline.js] [wpdOpenWindow] EXCEPTION: "+ex+"\n");
  }    		
}  

function pathExists(filePath)
{        
  dump("pathExists "+filePath+"\n");
  var obj_File = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);     
  try {
    obj_File.initWithPath(filePath);     
    return obj_File.exists();
	} catch(ex) {
    return false;
  }
}

function URLToFilePath(aURL) 
{         
  dump("URLToFilePath "+aURL+"\n");                          
	var obj_File = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);                                                                                    
  var obj_FPH = Components.classes["@mozilla.org/network/protocol;1?name=file"].getService(Components.interfaces.nsIFileProtocolHandler);     
  try {
    return obj_FPH.getFileFromURLSpec(aURL).path;           
  } catch(ex) {
    return aURL;
  }
}
                                        

const wpdCommandLineHandler = 
{  	
	helpInfo: "	-wpd_srcurl \"[URL]\"	-wpd_dest	\"[Dest]\"  Save the webpage from [URL] to [Dest] directory.\n"+
	          " -wpd_srcbatch \"[Batch File]\"	 -wpd_dest	\"[Dest]\"  Process the Batch File and save to [Dest] directory.\n"+
	          " -wpd_srcbatch \"[Batch File]\"  Process the Batch File and save to [Batch File] directory.\n"+
	          " -wpd_srcdir \"[Source]\" -wpd_dest	\"[Dest]\"  Save from [Source] to [Dest] directory.\n"+
	          " -wpd_srcdir \"[Source]\"  Use [Source] directory as destination, no files are written.\n"+
	          " -wpd_srcdir  Use current directory as source and destination, no files are written.\n"+
	          " -wpd_screenshot \"[FileName]\" (could be added to all above) Generate full images from the webpages\n"+
	          " -wpd_testdir \"[Test]\"  Report URLs, URL IDs and Screenshots inside the [Test] directory\n"+
	          " -wpd_testdir  Report URLs, URL IDs and Screenshots inside the current directory\n"+
	          " -wpd_collect  Copy and rename screenshots in the current directory to \"wpd_collect\"\n"+
	          " -wpd_collect \"[Dest]\" Copy and rename screenshots in the current directory to \"[Dest]\"\n"+
	          " -wpd_collect \"[Source]\" -wpd_dest \"[Dest]\" Copy and rename screenshots from [Source] to [Dest]\n"+
	          " -wpd_update  Don't generate different versions; skip existing directories\n",

	handle: function(aCmdLine)
	{                         
               
	  try {                                        
      var uri=aCmdLine.handleFlagWithParam("wpd_srcurl", false);
      var batch=aCmdLine.handleFlagWithParam("wpd_srcbatch", false);
      var skipVersion=aCmdLine.handleFlag("wpd_update",false);
      try {        
        var dest=aCmdLine.handleFlagWithParam("wpd_dest", false);        
      } catch(ex) {        
        var dest=aCmdLine.handleFlag("wpd_dest", false);
      }   
      try {
        var localdir=aCmdLine.handleFlagWithParam("wpd_srcdir", false);        
      } catch(ex) {
        var localdir=aCmdLine.handleFlag("wpd_srcdir", false);
      }        
      try {
        var collectdir=aCmdLine.handleFlagWithParam("wpd_collect",false);        
      } catch(ex) {
        var collectdir=aCmdLine.handleFlag("wpd_collect", false);        
      }
      try {
        var testdir=aCmdLine.handleFlagWithParam("wpd_testdir",false);        
      } catch(ex) {
        var testdir=aCmdLine.handleFlag("wpd_testdir", false);
      }          
      try {
        var scrshot=aCmdLine.handleFlagWithParam("wpd_screenshot", false);       
      } catch(ex) {
        var scrshot=aCmdLine.handleFlag("wpd_screenshot", false);
      }
    } catch (ex) {    
    	aCmdLine.preventDefault = true;		 // prevents opening a default browserwindow
      dump("ERROR: parameter format not correct...\n");
    }
      
   	try {  
      if ((uri) || (batch) || (localdir) || (testdir) || (collectdir)) 
  		{                                
  			dump("\n[commandline.js] [wpdCommandLineHandler.handle] command line options found!\n");                                 
  			try {               		  			  
  			  if (skipVersion) { 
  			    skipVersion="true" 
  			  } else {
  			    skipVersion="false";
  			  }			  
  			  if (scrshot==true) {  // set default screenshot filename
  			    scrshot="online";   
  			    if (localdir) scrshot="local";
  			  } 
  			  if (!dest) dest="";
  			  if (!scrshot) scrshot="";
  			  // set to current path if necessary...
  				if (dest==true) dest=aCmdLine.resolveFile(".").path; 
          if (localdir==true) localdir=aCmdLine.resolveFile(".").path;      
          if (testdir==true) testdir=aCmdLine.resolveFile(".").path;
          if (collectdir==true) collectdir=aCmdLine.resolveFile(".").path;                           
          
    			if (batch) {
       			batch=URLToFilePath(batch);
       			if (!pathExists(batch)) batch=aCmdLine.resolveFile(batch).path; 
    			  wpdOpenWindow(aCmdLine.resolveURI("about:blank"),"webPageDumpBatch(\""+batch.replace(/[\\]/g,"\\\\") +"\",\""+dest.replace(/[\\]/g,"\\\\")+"\",\""+scrshot.replace(/[\\]/g,"\\\\")+"\","+skipVersion+")");
   			  }
    			if (dest) wpdOpenWindow(aCmdLine.resolveURI(uri),"webPageDumpClose(\""+dest.replace(/[\\]/g,"\\\\")+"\",\""+scrshot+"\")");
    			if (localdir) wpdOpenWindow(aCmdLine.resolveURI("about:blank"),"webPageDumpDir(\""+localdir.replace(/[\\]/g,"\\\\") +"\",\""+dest.replace(/[\\]/g,"\\\\") +"\",\""+scrshot.replace(/[\\]/g,"\\\\")+"\","+skipVersion+")"); 
    			if (testdir) wpdOpenWindow(aCmdLine.resolveURI("about:blank"),"webPageDumpTest(\""+testdir.replace(/[\\]/g,"\\\\") + "\")");
    			if (collectdir) wpdOpenWindow(aCmdLine.resolveURI("about:blank"),"webPageDumpCollect(\""+collectdir.replace(/[\\]/g,"\\\\") + "\",\""+dest.replace(/[\\]/g,"\\\\") +"\")");  
    		} catch(ex) {  
    		  dump("[commandline.js] [wpdCommandLineHandler.handle] EXCEPTION: "+ex+"\n");
    		}
  			aCmdLine.preventDefault = true;		 // prevents opening a default browserwindow
  		}
  	} catch(ex) {  	  
  	  aCmdLine.preventDefault = true;		 // prevents opening a default browserwindow
  	  dump("EXCEPTION: "+ex+"\n");
  	}
  	
	},   
	
	QueryInterface: function(aIID)
	{
		if (!aIID.equals(Components.interfaces.nsISupports) && 
		    !aIID.equals(Components.interfaces.nsICommandLineHandler))
		{
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		
		return this;
	}                                         
	
};

const wpdModuleAndFactory = 
{   	
	mCID: Components.ID("{9231a64c-215b-4f10-a19d-6348aa3fbb1c}"),
	mContractID: "@dbai/webpagedump-clh;1",
	mCategory: "c-webpagedump",
	mCatMan:null,

	getClassObject: function(aCompMgr, aCID, aIID)
	{
		if (!aCID.equals(this.mCID))
		{
			throw Components.results.NS_ERROR_NOT_REGISTERED;
		}
		
		return this.QueryInterface(aIID);
	},

	registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
	{
		aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		aCompMgr.registerFactoryLocation(this.mCID, this.mCategory, this.mContractID, aFileSpec, aLocation, aType);
		
		this.mCatMan = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
		this.mCatMan.addCategoryEntry("command-line-handler", this.mCategory, this.mContractID, true, true);
	},

	unregisterSelf: function(aCompMgr, aLocation, aType)
	{
		aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		aCompMgr.unregisterFactoryLocation(this.mCID, aLocation);
		
		Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
		this.mCatMan.deleteCategoryEntry("command-line-handler", this.mCategory, true);
	},

	canUnload: function(aCompMgr)
	{
		return true;
	},

	createInstance: function(aOuter, aIID)
	{
		if (aOuter != null)
		{
			throw Components.results.NS_ERROR_NO_AGGREGATION;
		}
		
		return wpdCommandLineHandler.QueryInterface(aIID);
	},

	lockFactory: function(aLock) { },

	QueryInterface: function(aIID)
	{
		if (!aIID.equals(Components.interfaces.nsISupports) && 
		    !aIID.equals(Components.interfaces.nsIModule) && 
		    !aIID.equals(Components.interfaces.nsIFactory))
		{
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		
		return this;
	}
};                

function NSGetModule(aComMgr, aFileSpec)
{                      
	dump("\n[commandline.js] [NSGetModule] initialising wpd commandline handler\n");    
	return wpdModuleAndFactory; 
}   

                                   
